module Metamorphosis
  class PrefixParser
    attr_reader :prefixes

    def initialize(prefixes, available_units)
      @prefixes = prefixes
      @available_units = available_units
    end

    # Given a known set of unit names, returns the prefix value,
    # and the base unit name
    def parse(unit_text)
      unit_text = unit_text.to_s
      @prefixes.each do |prefix, value|
        unit = parse_unit(unit_text, prefix)
        next unless unit

        return [value, unit]
      end
      [1.0, unit_text.to_sym]
    end


    #############################################
    private

    def parse_unit(unit_text, prefix)
      md = /^#{prefix}(.+)/.match(unit_text)
      return unless md
      unit = md[1].to_sym

      @available_units.include?(unit) ? unit : nil
    end
  end
end
