module Metamorphosis
  class UnitRegistry

    def initialize
      @categories = Hash.new{|h,k| h[k] = {} }
      @unit_category_lookup = Hash.new{|h,k| h[k] = Set.new }
    end

    def register(category, unit, conversion)
      category_symbol = category.to_sym
      unit_symbol = unit.to_sym
      @categories[category_symbol][unit_symbol] = conversion
      @unit_category_lookup[unit_symbol] << category_symbol
    end

    def category_names
      @categories.keys
    end

    def unit_categories(unit)
      unit_symbol = unit.is_a?(UnitValue) ? unit.unit_symbol : unit.to_sym
      @unit_category_lookup[unit_symbol]
    end


    def conversion_factor(category, unit)
      @categories[category.to_sym][unit]
    end

    def include?(unit)
      @unit_category_lookup.include?(unit.to_sym)
    end

  end
end
